"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class AmpClincialOrExperimentalEvidence(ProtocolElement):
    """
    Amp Clinical or Experimental Evidence, the level will define the
    overal clasification of the variant together with the tiering.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "category",
        "level",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "category": reports_6_8_0.AmpClinicalOrExperimentalEvidenceCategory,
            "level": reports_6_8_0.AmpClinicalOrExperimentalEvidenceLevel,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_5 import reports as reports_6_8_0

        return {
            "org.gel.models.report.avro.AmpClinicalOrExperimentalEvidenceCategory": reports_6_8_0.AmpClinicalOrExperimentalEvidenceCategory,
            "org.gel.models.report.avro.AmpClinicalOrExperimentalEvidenceLevel": reports_6_8_0.AmpClinicalOrExperimentalEvidenceLevel,
            "org.gel.models.report.avro.AmpClincialOrExperimentalEvidence": reports_6_8_0.AmpClincialOrExperimentalEvidence,
        }

    __slots__ = [
        "category",
        "level",
        "description",
    ]

    def __init__(
        self,
        category,
        level,
        description=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_8_0.AmpClincialOrExperimentalEvidence model.

        :param category:
            As denined in AMP guidelines: therapeutic, diagnosis or prognosis
        :type category: AmpClinicalOrExperimentalEvidenceCategory
        :param level:
            As denined in AMP guidelines: levelA, levelB, levelC, levelD
        :type level: AmpClinicalOrExperimentalEvidenceLevel
        :param description:
            Description of the evidence
        :type description: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.8.0"
